package;

import flixel.FlxBasic;
import flixel.FlxG;
import flixel.FlxObject;
import flixel.group.FlxGroup;
import openfl.Assets;

class GoalPostHolder extends FlxBasic
{
  @:isVar
  public var posts(get, set):FlxGroup;
  
  public function new(Parent:PlayState, levelId:Int)
  {
    super();
    posts = new FlxGroup();
    Parent.add(posts);
    
    var coords:Array<String>;
    var entities:Array<String> = Assets.getText("assets/data/flags.csv").split("\n");  
    var goalPost:GoalPost;
    var goalCounter:Int = 0;

    for (j in 0...(entities.length)) 
    {
      coords = entities[j].split(",");  
      
      goalPost = new GoalPost(goalCounter, Std.parseInt(coords[0]), Std.parseInt(coords[1]));
      posts.add(goalPost); 
      goalCounter++;
      
      posts.getFirstExisting().active = false;
      posts.getFirstExisting().visible = false;
    }
  }
  override public function destroy():Void
  {
    posts.destroy();
  }

  public function deactivate(currentGoal:GoalPost):Void
  {
    currentGoal.active  = false;
    currentGoal.visible = false;
  }

  public function activate(currentGoal:GoalPost):Void
  {
    currentGoal.active  = true;
    currentGoal.visible = true;
  }

  function get_posts() 
  {
    return posts;
  }

  function set_posts(posts) 
  {
    return this.posts = posts;
  }
}