package ;

import flixel.FlxBasic;
import flixel.FlxG;
import flixel.FlxSprite;
import flixel.group.FlxGroup;
import flixel.group.FlxTypedGroup;
import flixel.text.FlxText;
import flixel.util.FlxColor;
using flixel.util.FlxSpriteUtil;

class HUD extends FlxTypedGroup<FlxSprite>
{
    private var _sprBack:FlxSprite;
    private var _txtHealth:FlxText;
    private var _txtMoney:FlxText;
    private var _sprHealth:FlxSprite;
    private var _sprMoney:FlxSprite;

    private var _grape:FlxSprite;
    private var _kiwi:FlxSprite;
    private var _lemon:FlxSprite;
    private var _tomato:FlxSprite;
    private var _players:Array<FlxSprite>;
    private var _candies:Array<Dynamic>;

    public function new()
    {
        super();

        _players = new Array<FlxSprite>();

        _tomato = new FlxSprite(0, 70, AssetPaths.UI_Tomato__png);
        add(_tomato);
        _players.push(_tomato);

        _grape = new FlxSprite(0, 0, AssetPaths.UI_Grape__png);
        add(_grape);
        _players.push(_grape);


        switch (Reg.player_amount) 
        {
            case 4:
                _lemon = new FlxSprite(150, 0, AssetPaths.UI_Lemon__png);
                add(_lemon);
                _players.push(_lemon);
                _kiwi = new FlxSprite(150, 70, AssetPaths.UI_Kiwi__png);
                add(_kiwi);
                _players.push(_kiwi);
            case 3:
                _lemon = new FlxSprite(150, 0, AssetPaths.UI_Lemon__png);
                add(_lemon);
                _players.push(_lemon);
        }

        forEach(function(spr:FlxSprite) {
            spr.scrollFactor.set();
        });

        _candies = new Array<Dynamic>();
        var candy:Candy;
        for (i in 0..._players.length)
        {
            _candies.push(i);
            _candies[i] = [];
            for (j in 0...3)
            {
                candy = new Candy(_players[i].x + 30 + (j * 20), _players[i].y + 30);
                add(candy);
                _candies[i].push(candy);
            }
        }
    }

    public function updateHUD(playerId:Int, score:Int):Void
    {
        _candies[playerId][score - 1].updateCandy();
    }
}