package;

import flixel.FlxSprite;
import flixel.FlxG;
/**
 * ...
 * @author Ronan Roquais
 */
class LevelEntity extends FlxSprite
{
  public var _typeId:Int = -1;
  public var stepId:Int;
  private var _disappearTimer:Float = 1.0;
  private var _localTimer:Float = -1.0;
  public function new(X:Float, Y:Float, animId:Int, stepId:Int)
  {
    super(X, Y);
		_typeId = animId;
    this.stepId = stepId;
    loadGraphic("assets/art/objects.png", true, 20, 20, false);
    animation.add("idle", [animId]);
    animation.play("idle");
    if (_typeId == 4)
    {
      immovable = true;
    }
  }
  
  public function onTouchAction(player:Player)
  {
    if(_typeId == 1)
    {
      player.kill();
    }
    else if (_typeId == 2)
    {
      player.bounce();
    }
    else if (_typeId == 3)
    {
      player.speedUp();
      this.kill();
    }
    else if (_typeId == 4)
    {
      var lastX = this.x;
      var lastY = this.y;
      FlxG.collide(player, this);
      x = lastX;
      y = lastY;
    }
    else if (_typeId == 5)
    {
      if (_localTimer == -1.0)
      {
        _localTimer = 0;
      }
      else
      FlxG.collide(player, this);
    }
  }
  public override function update():Void
  {
    if(_localTimer >= 0)
    {
      _localTimer += FlxG.elapsed;
      this.alpha = _disappearTimer-_localTimer;
    }
    if (_localTimer > _disappearTimer)
    {
      this.kill();
    }
    super.update();
  }
}