package;

import flash.geom.Point;
import flixel.FlxBasic;

class LevelHolder extends FlxBasic
{  
  @:isVar
  public var goalPosts(get, null):GoalPostHolder;
  
  @:isVar
  public var levelEntities(get, set):EntitiesHolder;
  
  @:isVar
  public var playerPos(get, set):Column;
  
  @:isVar
  public var currentDirection(get, set):Int;

  @:isVar
  public var columns:Array<Column>;
  
  public function new(Parent:PlayState):Void 
  {
    super();
    var _background:Background;
    _background = new Background(Parent, 0);
    goalPosts = new GoalPostHolder(Parent, 0);
    levelEntities = new EntitiesHolder(Parent, 0);
    columns = [];
    Reg.level = 0;
    currentDirection = 0;
    setLevelOnePositions();
    setStepPositions(0);
  }
  
  override public function destroy():Void {
    goalPosts.destroy();
    levelEntities.destroy();
  }

  public function play_next():Void
  {
    // levels[Reg.level].destroy(hasBeenRemoved);
    Reg.level++;
  }

  private function setLevelOnePositions():Void
  {
    for (i in 0...2) {
      columns.push(new Column(i));
      for (k in 0...Reg.max_players)
      {
        columns[i].rows.push(new Point(0, 0));
      }
    }

    columns[0].rows[0] =  new Point(32, 585);
    columns[0].rows[1] =  new Point(32, 460);
    columns[0].rows[2] =  new Point(32, 348);
    columns[0].rows[3] =  new Point(32, 231);

    columns[1].rows[0] =  new Point(1240, 470);
    columns[1].rows[1] =  new Point(1240, 350);
    columns[1].rows[2] =  new Point(1240, 230);
    columns[1].rows[3] =  new Point(1240, 103);
  }
  
  public function setStepPositions(step:Int):Void
  {
    var entity:LevelEntity ;
    for (i in 0...levelEntities.levelEntities.length)
    {
      entity = cast(levelEntities.levelEntities.members[i], LevelEntity);
      if(entity.stepId == step)
        entity.revive();
      else 
        entity.kill();
    }
  }

  private function hasBeenRemoved():Void
  {
    // levels[Reg.level].play();
  }

  function get_currentDirection() 
  {
    return currentDirection;
  }

  function set_currentDirection(value) 
  {
    return currentDirection = value;
  }

  function get_playerPos() 
  {
    return columns[currentDirection];
  }

  function set_playerPos(value) 
  {
    return columns[currentDirection] = value;
  }

  function get_goalPosts() 
  {
    return this.goalPosts;
  }

/*  function set_goalPosts(goalPosts) 
  {
    return this.goalPosts = goalPosts;
  }*/
  function get_levelEntities() 
  {
    return this.levelEntities;
  }

  function set_levelEntities(levelEntities) 
  {
    return this.levelEntities = levelEntities;
  }
}