package;

import flixel.util.FlxSave;

/**
 * Handy, pre-built Registry class that can be used to store 
 * references to objects and other things for quick-access. Feel
 * free to simply ignore it or change it in any way you like.
 */
class Reg
{
  public static var max_players:Int = 4;
  public static var player_amount:Int;
  public static var max_level:Int = 1;
  
  public static var stageWidth:Int = 1280;
  public static var stageHeight:Int = 720;

  public static var SoundExtension:String = ".wav";
  /**
   * Generic levels Array that can be used for cross-state stuff.
   * Example usage: Storing the levels of a platformer.
   */
  public static var levels:Array<Dynamic> = [];
  /**
   * Generic level variable that can be used for cross-state stuff.
   * Example usage: Storing the current level number.
   */
  public static var level:Int = 0;
  /**
   * Generic scores Array that can be used for cross-state stuff.
   * Example usage: Storing the scores for level.
   */
  public static var scores:Array<Dynamic> = [];
  /**
   * Generic score variable that can be used for cross-state stuff.
   * Example usage: Storing the current score.
   */
  public static var score:Int = 0;
  public static var player_id:Int;

  /**
   * Generic bucket for storing different FlxSaves.
   * Especially useful for setting up multiple save slots.
   */
  public static var saves:Array<FlxSave> = [];
  
  public static var usePads:Bool = true;
  
  public static var playerKeys:Array<Array<Array<String>>> = [[["W"], ["S"], ["A"], ["D"], ["W"], ["H"], ["T"], ["Y"], ["TAB"]],
    [["UP"], ["DOWN"], ["LEFT"], ["RIGHT"], ["UP"], ["L"], ["I"], ["O"], ["ENTER"]],
    [[], [], ["O"], ["P"], ["I"], [], [], [], ["["]],
    [[], [], ["B"], ["N"], ["V"], [],[],[],["SPACE"]]];
  public static var frplayerKeys:Array<Array<Array<String>>> = [[["Z"], ["S"], ["Q"], ["D"], ["Z"], ["H"], ["T"], ["Y"], ["TAB"]],
    [["UP"], ["DOWN"], ["LEFT"], ["RIGHT"], ["UP"], ["L"], ["I"], ["O"], ["CTRL"]],
    [[], [], ["O"], ["P"], ["I"], [], [], [], ["ENTER"]],
    [[], [], ["B"], ["N"], ["V"], [],[],[],["SPACE"]]];
}