package;

import flixel.FlxG;
import flixel.FlxState;
import flixel.group.FlxGroup;
import flixel.ui.FlxButton;
import flixel.util.FlxDestroyUtil;
import flixel.FlxSprite;
import flixel.input.gamepad.FlxGamepad;
using flixel.util.FlxSpriteUtil;
import flixel.tile.FlxTilemap;
import openfl.Assets;
import flash.geom.ColorTransform;
import flixel.input.gamepad.XboxButtonID;
import flixel.util.FlxColor;


/**
 * A FlxState which can be used for the game's menu.
 */
class WinningState extends FlxState
{
  // How many UI shall we click on before playing
  private var _steps:Int = 2;
  private var _currentStep:Int = 0;
  private var _counter:Int = 0;

  private var _playerChoiceBtn:Array<Dynamic> = [];
  private var _padChoiceBtn:Array<Dynamic> = [];

  private var _btnPlay:FlxButton;
  private var _btnPlayKey:FlxButton;
  private var _btnPlayer2vs2:FlxButton;
  private var _btnPlayer3vs3:FlxButton;
  private var _btnPlayer4vs4:FlxButton;
  private var _btnStart:FlxButton;
  private var _gamepads:Array<FlxSprite>;
  private var p1Controls:Controls;

  private var _staticBg:FlxSprite;
  /**
   * Function that is called up when to state is created to set it up. 
   */
  private var _activePlayers:Array<Bool>;
  override public function create():Void
  {
    _staticBg = new FlxSprite();
    _staticBg.loadGraphic("assets/images/winning-state.png");
    add(_staticBg);
    var names:Array<String>=["Tomato", "Grape", "Lemon", "Kiwi"];
    var text = new flixel.text.FlxText(0,0,0,names[Reg.player_id] + " HAS CREAM!" );
    text.screenCenter();
    text.setFormat(null, 48, FlxColor.WHITE, "center");
    add(text);
    super.create();
  }

  /**
   * Function that is called once every frame.
   */
  override public function update():Void
  {
    _counter++;
    super.update();
    if (_counter >= 500)
    {
      FlxG.switchState(new MenuState());
    }
  } 
}